// file.h
// definition et fonctions de manipulation des files
// le 23 mars 1997
// le type f_elt est a definir dans le fichier utilisant des files
// AVANT d'inclure le fichier file.h

struct f_cellule{
   f_elt       info;
   f_cellule * suiv;
};

struct file {
   f_cellule * first;
   f_cellule * last;
   };

//////////////// primitives de gestion d'une file /////////////////
void init_file(file & une_file);
int file_vide(file une_file);
void enfiler(f_elt valeur, file & une_file);
void defiler(f_elt & valeur, file & une_file);
///////////////////////////////////////////////////////////////////

void init_file(file & une_file) {
   une_file.first = NULL;
   une_file.last = NULL;
}

int file_vide(file une_file) {
   return (une_file.first == NULL);
}

void enfiler(f_elt valeur, file & une_file){
   f_cellule * p_aux;
   p_aux = new f_cellule;
   p_aux->info = valeur;
   p_aux->suiv = NULL;
   if (file_vide(une_file))
	une_file.first = p_aux;
   else
	une_file.last->suiv = p_aux;
   une_file.last = p_aux;
}

void defiler(f_elt & valeur, file & une_file){
   f_cellule * p_aux;
   p_aux = une_file.first;
   valeur = p_aux->info;
   une_file.first = p_aux->suiv;
   if (une_file.first == NULL)
	une_file.last = NULL;
   delete p_aux;
}

